<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if(!class_exists('IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init')){
	/*
	 * Class Name IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init
	 *
	 * Class is used for returning all reports data
	 *	  
	*/
	class IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init{
		
		/* variable declaration*/
		public $constants 			=	array();
		
		/* variable declaration*/
		public $cogs_constants 		=	array();
		
		/* variable declaration*/
		public $cost_of_goods 		=	NULL;
		
		/**
		* __construct
		*/
		function __construct($constants = array(), $plugin_key = ""){
			$this->constants	= array_merge($this->constants, $constants);
			
			//Premium Gold
			add_action( "ic_commerce_ultimate_report_init", 				array($this, "get_cog_ic_commerce_init"),101,2);
			if($this->constants['is_wc_ge_3_0_5']){
				add_action( 'woocommerce_new_order_item',  				array($this, 'set_cog_woocommerce_add_order_item_meta'), 101, 3 );
			}else{
				add_action( 'woocommerce_add_order_item_meta',  				array($this, 'set_cog_woocommerce_add_order_item_meta'), 101, 3 );
			}
			add_action( 'woocommerce_checkout_update_order_meta', 			array($this, 'set_cog_woocommerce_checkout_update_order_meta'), 101 );
			add_action( 'woocommerce_save_product_variation',				array($this, 'set_woocommerce_save_product_variation'),30,2);
			add_action( "ic_commerce_ultimate_report_page_init", 		array($this, "get_ic_commerce_ultimate_report_page_init"),101,2);
		}
		
		/**
		* get_ic_commerce_ultimate_report_page_init
		* @param array $constants 
		* @param string $admin_page 
		* @return void
		*/
		function get_ic_commerce_ultimate_report_page_init($constants = array(), $admin_page = ""){
			if($admin_page == "icwoocommerceultimatereport_cross_tab_page"){
				require_once("ic_commerce_ultimate_report_cog_crosstab.php");
				$new = new IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Crosstab($constants);
			}
		}
		/**
		* set_woocommerce_save_product_variation
		* @param integer $variation_id 
		* @param string $i 
		* @return void
		*/
		function set_woocommerce_save_product_variation( $variation_id = 0, $i = 0 ){
			$this->get_cost_of_goods_class($this->constants,$this->constants['plugin_key']);
			$this->cost_of_goods->set_woocommerce_save_product_variation($variation_id, $i);
		}
		/**
		* get_cost_of_goods_class
		* @param array $constants 
		* @param string $plugin_key 
		* @return object
		*/
		function get_cost_of_goods_class($constants = array(), $plugin_key = ""){			
			if($this->cost_of_goods == NULL){
				require_once('ic_commerce_ultimate_report_cog.php');
				$this->cost_of_goods = new IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods($constants,$plugin_key);
				$this->cost_of_goods->define_constant();
			}
			return $this->cost_of_goods;
		}
		/**
		* get_cog_ic_commerce_init
		* @param array $constants 
		* @param string $plugin_key 
		* @return object
		*/
		function get_cog_ic_commerce_init($constants = array(), $plugin_key = ""){			
			$this->get_cost_of_goods_class($constants,$plugin_key);
			$this->cost_of_goods->admin_init();
			
			$admin_page = isset($_REQUEST['page']) ? $_REQUEST['page'] : '';
			$plugin_key	= isset($this->constants['plugin_key']) ? $this->constants['plugin_key'] : '';
			if($admin_page == $plugin_key."_page"){
				require_once('ic_commerce_ultimate_report_cog_dashboard.php');
				$dashboard = new IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Dashboard($constants);
			}
			
			
		}
		/**
		* set_cog_woocommerce_add_order_item_meta
		* @param integer $item_id 
		* @param string $values 
		* @param integer $cart_item_key 
		* @return void
		*/
		function set_cog_woocommerce_add_order_item_meta($item_id = 0, $values, $cart_item_key = 0){
			$this->get_cost_of_goods_class($this->constants,$this->constants['plugin_key']);
			
			if(!$this->cost_of_goods->get_cogs_enabled()) return false;
			$this->cost_of_goods->woocommerce_add_order_item_meta($item_id, $values, $cart_item_key);
		
		}
		/**
		* set_cog_woocommerce_checkout_update_order_meta
		* @param integer $order_id 
		*
		* @return void
		*/
		function set_cog_woocommerce_checkout_update_order_meta($order_id){
			$this->get_cost_of_goods_class($this->constants,$this->constants['plugin_key']);
			if(!$this->cost_of_goods->get_cogs_enabled()) return false;
			$this->cost_of_goods->woocommerce_checkout_update_order_meta($order_id);
		}
		
		
		
		
	}//End IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init
}//End IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init