<?php 
/**
Plugin Name: Woocommerce Ultimate Reports
Author: persianscript.ir
Description: The latest release of our WooCommerce Report Plug-in has all features of Gold version plus new features like Projected Vs Actual Sales, Comprehensive Tax based Reporting, Improvised Dashboard, Filters by Variation Attributes, Sales summary by Map View, Graphs and much more.
Version: 2.6
Author URI: http://www.persianscript.ir

Copyright:  2017 - http://woochamps.com/ - All Rights Reserved

Tested WooCommerce Version: 3.4.1
Tested Wordpress Version: 4.9.6

Last Update Date: June  05, 2018

Text Domain: icwoocommerce_textdomains
Domain Path: /languages/
**/   

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if(!function_exists('init_icwoocommerceultimatereport')){
	
	if(!function_exists('ic_commerce_onload_search')){
		function ic_commerce_onload_search($onload_search = ''){
			return 'no';
		}
	}
	
	if(!function_exists('ic_commerce_onload_search_text')){
		function ic_commerce_onload_search_text($onload_search_text = ''){		
			$onload_search_text = "<div class=\"order_not_found\">".__("In order to view the results please hit \"<strong>Search</strong>\" button.",'icwoocommerce_textdomains')."</div>";
			return $onload_search_text;
		}	
	}
	
	function init_icwoocommerceultimatereport() {
		global $woocommerce_ultimate_report, $woocommerce_ultimate_report_constant;
		
		$constants = array(
				"version" 				=> "2.6"
				,"product_id" 			=> "1583"
				,"plugin_key" 			=> "icwoocommerceultimatereport"
				,"plugin_main_class" 	=> "Woocommerce_Ultimate_Report"
				,"plugin_instance" 		=> "woocommerce_ultimate_report"
				,"plugin_dir" 			=> 'woocommerce-ultimate-report'
				,"plugin_file" 			=> __FILE__
				,"plugin_role" 			=> apply_filters('ic_commerce_ultimate_report_plugin_role','manage_woocommerce')//'read'
				,"per_page_default"		=> 5
				,"plugin_parent_active" => false
				,"color_code" 			=> '#77aedb'
				,"plugin_parent" 		=> array(
					"plugin_name"		=> "WooCommerce"
					,"plugin_slug"		=> "woocommerce/woocommerce.php"
					,"plugin_file_name"	=> "woocommerce.php"
					,"plugin_folder"	=> "woocommerce"
					,"order_detail_url"	=> "post.php?&action=edit&post="
				)			
		);
		
		$constants['is_wc_ge_27'] 		= version_compare( WC_VERSION, '2.7', '<' );
		$constants['is_wc_ge_3_0'] 		= version_compare( WC_VERSION, '3.0', '>=' );
		$constants['is_wc_ge_3_0_5'] 	= version_compare( WC_VERSION, '3.0.5', '>=' );
		
		add_filter('ic_commerce_onload_search',		'ic_commerce_onload_search');
		add_filter('ic_commerce_onload_search_text','ic_commerce_onload_search_text');
		
		require_once('includes/ic_commerce_ultimate_report_functions.php');
		
		load_plugin_textdomain('icwoocommerce_textdomains', WP_PLUGIN_DIR.'/'.$constants['plugin_dir'].'/languages',$constants['plugin_dir'].'/languages');
		$constants['plugin_name'] 		= __('Ultimate Woocommerce Report', 	'icwoocommerce_textdomains');
		$constants['plugin_menu_name'] 	= __('Ultimate Report',								'icwoocommerce_textdomains');
		$constants['admin_page'] 		= isset($_REQUEST['page']) ? $_REQUEST['page'] : "";
		$constants['is_admin'] 			= is_admin();
		
		$constants = apply_filters('ic_commerce_ultimate_report_init_constants', $constants, $constants['plugin_key']);
		do_action('ic_commerce_ultimate_report_textdomain_loaded',$constants, $constants['plugin_key']);
		
		$woocommerce_ultimate_report_constant = $constants;
		
		require_once('includes/ic_commerce_ultimate_report_add_actions.php');
		
		if ($constants['is_admin']) {
				
				require_once('includes/ic_commerce_ultimate_report_init.php');
								
				if(!class_exists('Woocommerce_Ultimate_Report')){class Woocommerce_Ultimate_Report extends IC_Commerce_Ultimate_Woocommerce_Report_Init{}}
				
				$woocommerce_ultimate_report 			= new Woocommerce_Ultimate_Report( __FILE__, $woocommerce_ultimate_report_constant);
		}
	}
}

add_action('init','init_icwoocommerceultimatereport', 100);

if(!function_exists('get_ic_commerce_ultimate_report_textdomain_loaded')){	
	function get_ic_commerce_ultimate_report_textdomain_loaded($constants = array(), $plugin_key = ""){
				
		$path = WP_PLUGIN_DIR."/woocommerce-ultimate-report/includes/";
		
		$path.'ic_commerce_ultimate_report_cog_init.php';
		if(file_exists($path.'ic_commerce_ultimate_report_cog_init.php')){
			require_once('includes/ic_commerce_ultimate_report_cog_init.php');
			$IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init = new IC_Commerce_Ultimate_Woocommerce_Report_Cost_of_Goods_Init($constants, $plugin_key);
		}
		
	}
	add_action('ic_commerce_ultimate_report_textdomain_loaded','get_ic_commerce_ultimate_report_textdomain_loaded', 100,2);
}


